<?php if (!defined('SAFE')) { die('invalid'); }
/*
Name=VATMOSS sales reports
Description=A report of sale totals for VATMOSS EU tax rules, valid since 01/2015 (attention: no custom SPBAS tax rules are considered in this report - it takes the net revenue and deducted the VAT tax rate for each country) - use on your own risk!
Author=Robert Harm (report developer: Waseem Senjer)
E-mail=info@mapsmarker.com (report developer: waseem.senjer@gmail.com)
Website=https://www.mapsmarker.com
Enable-Credits=Yes
*/
// Compile the report.
// --------------------------------------------------------------------------
// What start day?

$_POST['start']=(isset($_POST['start']))?$_POST['start']:date('m/d/Y');
$_POST['start']=(isset($_GET['start']))?$_GET['start']:$_POST['start'];
$start=strtotime($_POST['start']);
// What end day?
$_POST['end']=(isset($_POST['end']))?$_POST['end']:date('m/d/Y');
$_POST['end']=(isset($_GET['end']))?$_GET['end']:$_POST['end'];
$end=strtotime($_POST['end']);

// do the query here

$static_countries = array( 24 => 
	array(
		'country'=> 'Belgium',
		'ISO' => 'BE',
		'VAT' => '21',
		'id'  => 24
		),
	26 => 
	array(
		'country'=> 'Bulgaria',
		'ISO' => 'BG',
		'VAT' => '20',
		'id'  => 26
		),
	57=>
	array(
		'country'=> 'Czech Republic',
		'ISO' => 'CZ',
		'VAT' => '21',
		'id'  => 57
		),
	60=>
	array(
		'country'=> 'Denmark',
		'ISO' => 'DK',
		'VAT' => '25',
		'id'  => 60
		),
	58 =>
	array(
		'country'=> 'Germany',
		'ISO' => 'DE',
		'VAT' => '19',
		'id'  => 58
		),
	65 =>
	array(
		'country'=> 'Estonia',
		'ISO' => 'EE',
		'VAT' => '20',
		'id'  => 65
		),
	91 =>
	array(
		'country'=> 'Greece',
		'ISO' => 'GR',
		'VAT' => '23',
		'id'  => 91
		),
	69 =>
	array(
		'country'=> 'Spain',
		'ISO' => 'ES',
		'VAT' => '21',
		'id'  => 69
		),
	77 =>
	array(
		'country'=> 'France',
		'ISO' => 'FR',
		'VAT' => '20',
		'id'  => 77
		),
	100 =>
	array(
		'country'=> 'Croatia',
		'ISO' => 'HR',
		'VAT' => '25',
		'id'  => 100
		),
	104 =>
	array(
		'country'=> 'Ireland',
		'ISO' => 'IE',
		'VAT' => '23',
		'id'  => 104
		),
	112 =>
	array(
		'country'=> 'Italy',
		'ISO' => 'IT',
		'VAT' => '22',
		'id'  => 112
		),
	56 =>
	array(
		'country'=> 'Cyprus',
		'ISO' => 'CY',
		'VAT' => '19',
		'id'  => 56
		),
	137 =>
	array(
		'country'=> 'Latvia',
		'ISO' => 'LV',
		'VAT' => '21',
		'id'  => 137
		),
	135 =>
	array(
		'country'=> 'Lithuania',
		'ISO' => 'LT',
		'VAT' => '21',
		'id'  => 135
		),
	136 =>
	array(
		'country'=> 'Luxembourg',
		'ISO' => 'LU',
		'VAT' => '15',
		'id'  => 136
		),
	102 =>
	array(
		'country'=> 'Hungary',
		'ISO' => 'HU',
		'VAT' => '27',
		'id'  => 102
		),
	154 =>
	array(
		'country'=> 'Malta',
		'ISO' => 'MT',
		'VAT' => '18',
		'id'  => 154
		),
	167 =>
	array(
		'country'=> 'Netherlands',
		'ISO' => 'NL',
		'VAT' => '21',
		'id'  => 167
		),
	16 =>
	array(
		'country'=> 'Austria',
		'ISO' => 'AT',
		'VAT' => '20',
		'id'  => 16
		),
	180 =>
	array(
		'country'=> 'Poland',
		'ISO' => 'PL',
		'VAT' => '23',
		'id'  => 180
		),
	185 =>
	array(
		'country'=> 'Portugal',
		'ISO' => 'PT',
		'VAT' => '23',
		'id'  => 185
		),
	190 =>
	array(
		'country'=> 'Romania',
		'ISO' => 'RO',
		'VAT' => '24',
		'id'  => 190
		),
	201 =>
	array(
		'country'=> 'Slovenia',
		'ISO' => 'SI',
		'VAT' => '22',
		'id'  => 201
		),
	203 =>
	array(
		'country'=> 'Slovakia',
		'ISO' => 'SK',
		'VAT' => '22',
		'id'  => 203
		),
	72 =>
	array(
		'country'=> 'Finland',
		'ISO' => 'FI',
		'VAT' => '24',
		'id'  => 72
		),
	198 =>
	array(
		'country'=> 'Sweden',
		'ISO' => 'SE',
		'VAT' => '25',
		'id'  => 198
		),
	79 =>
	array(
		'country'=> 'United Kingdom',
		'ISO' => 'GB',
		'VAT' => '20',
		'id'  => 79
		)
);

$sales = get_sales_count_per_country($start,$end);
$other_sales = get_other_countries($start,$end);

// CSV processing
if (isset($_GET['csv']))
	{
	$csv="Country,ISO,# sales,gross sales,VAT%,VAT (euro),net sales";
	foreach ($sales as $country)
		{
			$vat_value = round( ($country['gross']/($static_countries[$country['country_id']]['VAT']+100))*$static_countries[$country['country_id']]['VAT'], 2);
			$net_sales = round(($country['gross']/($static_countries[$country['country_id']]['VAT']+100))*100, 2);
			$gross_sales = ($country['gross'] > 0)?$country['gross']:0;	 
			$csv.="\n";
			$csv.="{$country['name']},{$country['iso_code']},{$country['sales_count']},{$gross_sales},{$static_countries[$country['country_id']]['VAT']},{$vat_value},{$net_sales}";
		} 
	foreach ($other_sales as $country)
		{
			$vat = 20;
			$vat_value = round( ($country['gross']/($vat+100))*$vat, 2);
			$net_sales = round(($country['gross']/($vat+100))*100, 2);
			$gross_sales = ($country['gross'] > 0)?$country['gross']:0;
			$country_name = str_replace(',', '', $country['name']);
			$csv.="\n";
			$csv.="{$country_name},{$country['iso_code']},{$country['sales_count']},{$gross_sales},{$vat},{$vat_value},{$net_sales}";
		} 
	$for_start=str_replace('/', '-', $_POST['start']);
	$for_end=str_replace('/', '-', $_POST['end']);
	$csv = str_replace("&#039;", " ", $csv); //fix for data in tables Excel error
	reports::csv("VATMOSS-sales-report-{$for_start}-to-{$for_end}.csv", $csv);
	}
?>

<?php if (!isset($_GET['print'])): ?>
	<?php forms::action(); ?>
	<?php forms::hidden('mod', 0, 'reports'); ?>
	<?php forms::hidden('task', 0, 'dashboard'); ?>
	<?php forms::hidden('show_tab', 0, 'general'); ?>
	<?php forms::hidden('view_report', 0, 'vatmoss-sales-report'); ?>
	<?php echo _w('From:'); ?> <?php forms::text(uid('f'), 'start', $_POST['start'], 0, 'date datepicker'); ?> <?php echo _w('To:'); ?> <?php forms::text(uid('f'), 'end', $_POST['end'], 0, 'date datepicker'); ?> <?php forms::submit(0, 0, _w('View Report'), 0, 'form_button display_inline no_float', 1); ?>
	<?php echo _w('- or -'); ?>
	<a href='<?php echo href('reports', 'dashboard', array('show_tab' => 'general', 'view_report' => 'vatmoss-sales-report', 'start' => $_POST['start'], 'end' => $_POST['end'], 'print' => 'y')); ?>' target='_blank'><?php echo _w('Print'); ?></a>
	<?php echo _w('- or -'); ?>
	<a href='<?php echo href('reports', 'dashboard', array('show_tab' => 'general', 'view_report' => 'vatmoss-sales-report', 'start' => $_POST['start'], 'end' => $_POST['end'], 'csv' => 'y')); ?>'><?php echo _w('Download CSV'); ?></a>
	</form><br />
<?PHP else: echo '<br />'; endif; ?></p>

<?PHP /*if (!$invoices): ?>
	<tr <?PHP echo $data['alt']; ?>>
		<td colspan='8'><p class='no_matches_found'><?PHP echo _w('No invoices found!'); ?></p></td>
	</tr>
<?PHP else:*/  ?>

<?php if($_POST['view_report']== 'vatmoss-sales-report'):
		$totals = array();
 ?>
	<table class='data_grid'>
		<tr class='th'>
			<th><?PHP echo _w('Country'); ?></th>
			<th><?PHP echo _w('ISO'); ?></th>
			<th><?PHP echo _w('# sales'); ?></th>
			<th><?PHP echo _w('gross sales'); ?></th>
			<th><?PHP echo _w('VAT %'); ?></th>
			<th><?PHP echo _w('VAT €'); ?></th>
			<th><?PHP echo _w('net sales'); ?></th>
			
		</tr>
		<!-- list the static countries -->
		<?php foreach ($sales as $country):
			  
			  $vat_value = round( ($country['gross']/($static_countries[$country['country_id']]['VAT']+100))*$static_countries[$country['country_id']]['VAT'], 2);
			  $net_sales = round(($country['gross']/($static_countries[$country['country_id']]['VAT']+100))*100, 2);
			  $totals['sales_count'] += $country['sales_count'];
			  $totals['gross'] += $country['gross'];
			  $totals['vat_value'] += $vat_value;
			  $totals['net_sales'] += $net_sales;
		 ?>
		<tr <?PHP echo $data['alt']; ?>>
				<td><?PHP echo $country['name']; ?></td>
				<td><?PHP echo $country['iso_code']; ?></td>
				<td><?php echo $country['sales_count']; ?></td>
				<td><?php echo ($country['gross'] > 0)?$country['gross']:0; ?></td>
				<td><?PHP echo $static_countries[$country['country_id']]['VAT']; ?>%</td>
				<td><?php echo $vat_value; ?></td>
				<td><?php echo $net_sales; ?></td>
		</tr>
	<?php endforeach; ?>

	<!-- list other countries -->
	<?php foreach ($other_sales as $country):
			$vat = 20;
			$vat_value = round( ($country['gross']/($vat+100))*$vat, 2);
			$net_sales = round(($country['gross']/($vat+100))*100, 2);
			$totals['sales_count'] += $country['sales_count'];
			$totals['gross'] += $country['gross'];
			$totals['vat_value'] += $vat_value;
			$totals['net_sales'] += $net_sales;
		 ?>
		<tr <?PHP echo $data['alt']; ?>>
			<td><?PHP echo $country['name']; ?></td>
			<td><?PHP echo $country['iso_code']; ?></td>
			<td><?php echo $country['sales_count']; ?></td>
			<td><?php echo ($country['gross'] > 0)?$country['gross']:0; ?></td>
			<td><?php echo $vat ?>%</td>
			<td><?php echo $vat_value; ?></td>
			<td><?php echo $net_sales; ?></td>
		</tr>
	<?php endforeach; ?>

	<?PHP //foreach($totals as $currency_id => $all): $total=callback_totals($currency_id, $all); ?>
		<tr>
			<td colspan='2' class='totals_label'><b><?PHP echo _w('Totals:'); ?></b></td>
			<td class='totals green'><?PHP echo $totals['sales_count']; ?></td>
			<td class='totals green'><?PHP echo $totals['gross']; ?></td>
			<td class='totals'>--</td>
			<td  class='totals green'><?PHP echo $totals['vat_value']; ?></td>
			<td  class='totals green'><?PHP echo $totals['net_sales']; ?></td>
		</tr>
	<?PHP //endforeach; ?>
	</table>
<?php else: ?>
	<tr <?PHP echo $data['alt']; ?>>
		<td colspan='8'><p class='no_matches_found'><?PHP echo _w('No invoices found!'); ?></p></td>
	</tr>
<?PHP endif; ?>

<?php 
// functions to help

function get_sales_count_per_country($start = '',$end = ''){
	$start = ($start != '')?"paid_date>={$start} and":'';
	$end = ($end != '')?"paid_date<={$end} and":'';

	$sql = "
		SELECT 
		  c.name, c.iso_code, c.id as country_id, 
		  COUNT(a.invoice_id) as sales_count,
		  SUM(a.total_due) as gross
		FROM 
		  `m3_countries` c
		  LEFT JOIN `m3_customer_addresses` b
		    	ON c.`id` = b.`country_id`
		  LEFT JOIN `m3_invoices` a
			    ON b.`customer_id` = a.`customer_id`
			    AND {$start} {$end}  a.`status` = 'Paid' AND a.`deleted` ='No' 
		WHERE 
		  c.id IN (24,26,57,60,58,65,91,69,77,100,104,112,56,137,135,136,102,154,167,16,180,185,190,201,203,72,198,79)
		  GROUP BY c.name
	";
	
	$query=sql_query($sql);
	$sales = array();
	while ($rs= sql_fetch_assoc($query)) {
		$sales[] = $rs;
	}
	return $sales;
}

function get_other_countries($start ='', $end = ''){
 	$start = ($start != '')?"a.paid_date>={$start} and":'';
	$end = ($end != '')?"a.paid_date<={$end} and":'';

	$sql = "
		SELECT 
			  c.name, c.iso_code, c.id as country_id, 
			  COUNT(a.invoice_id) as sales_count,
			  SUM(a.total_due) as gross
		FROM 
		  `m3_countries` c
		  LEFT JOIN `m3_customer_addresses` b
		    ON c.`id` = b.`country_id`
		  LEFT JOIN `m3_invoices` a
		    ON b.`customer_id` = a.`customer_id`
		    AND {$start} {$end}  a.`status` = 'Paid' AND a.`deleted` ='No' 
		WHERE 
		  c.id NOT IN (24,26,57,60,58,65,91,69,77,100,104,112,56,137,135,136,102,154,167,16,180,185,190,201,203,72,198,79)
		  GROUP BY c.name
	";
	
 	$query=sql_query($sql);

	$countries = array();
	while ($rs= sql_fetch_assoc($query)) {
		$countries[] = $rs;
	}
	return $countries;
 }